package cn.com.qmth.dp.examcloud.oe.modules.find_duplicate_question_record;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.annotation.Resource;

import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.context.annotation.Scope;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Service;

import cn.com.qmth.dp.examcloud.oe.entity.question.ExamQuestionEntity;
import cn.com.qmth.dp.examcloud.oe.entity.question.ExamRecordQuestionsEntity;
import cn.com.qmth.dp.examcloud.oe.multithread.Consumer;
import cn.com.qmth.examcloud.commons.exception.StatusException;

@Service
@Scope("prototype")
public class FindDuplicateQuestionRecordConsumer extends Consumer<Long> {

    @Resource(name = "secondaryMongoTemplate")
    private MongoTemplate oeTemplate;

    @Override
    public void consume(Map<String, Object> param, Long recordId) {
        ExamRecordQuestionsEntity qs = getStudentAnswer(recordId);
        if (qs == null) {
            throw new StatusException("未找到考生作答:" + recordId);
        }
        InfoDto info = new InfoDto();
        info.setRecordId(recordId);
        Set<AnswerInfo> questionOrder = new LinkedHashSet<>();
        info.setQuestionOrder(questionOrder);
        boolean pick = false;
        Map<String, ExamQuestionEntity> map = new HashMap<>();

        Map<String, List<ExamQuestionEntity>> taoti = new LinkedHashMap<>();

        Map<String, List<ExamQuestionEntity>> taoti2 = new LinkedHashMap<>();
        for (ExamQuestionEntity q : qs.getExamQuestionEntities()) {
            if (q.getOrder() >= 41 && q.getOrder() <= 55) {
                List<ExamQuestionEntity> tem = taoti.get(q.getQuestionId());
                if (tem == null) {
                    tem = new ArrayList<>();
                    taoti.put(q.getQuestionId(), tem);
                }
                tem.add(q);
            } else if (q.getOrder() >= 56 && q.getOrder() <= 65) {
                List<ExamQuestionEntity> tem = taoti2.get(q.getQuestionId());
                if (tem == null) {
                    tem = new ArrayList<>();
                    taoti2.put(q.getQuestionId(), tem);
                }
                tem.add(q);
            } else {
                ExamQuestionEntity cq = map.get(q.getQuestionId());
                if (cq == null) {
                    map.put(q.getQuestionId(), q);
                } else {
                    pick = true;
                    if (StringUtils.isBlank(cq.getStudentAnswer())) {
                        questionOrder.add(new AnswerInfo(cq.getOrder(), "否"));
                    } else {
                        questionOrder.add(new AnswerInfo(cq.getOrder(), "是"));
                    }
                    if (StringUtils.isBlank(q.getStudentAnswer())) {
                        questionOrder.add(new AnswerInfo(q.getOrder(), "否"));
                    } else {
                        questionOrder.add(new AnswerInfo(q.getOrder(), "是"));
                    }
                }
            }
        }
        for (List<ExamQuestionEntity> list : taoti.values()) {
            if (list.size() > 5) {
                pick = true;
                for (ExamQuestionEntity q : list) {
                    if (StringUtils.isBlank(q.getStudentAnswer())) {
                        questionOrder.add(new AnswerInfo(q.getOrder(), "否"));
                    } else {
                        questionOrder.add(new AnswerInfo(q.getOrder(), "是"));
                    }
                }
            }
        }
        for (List<ExamQuestionEntity> list : taoti2.values()) {
            if (list.size() > 10) {
                pick = true;
                for (ExamQuestionEntity q : list) {
                    if (StringUtils.isBlank(q.getStudentAnswer())) {
                        questionOrder.add(new AnswerInfo(q.getOrder(), "否"));
                    } else {
                        questionOrder.add(new AnswerInfo(q.getOrder(), "是"));
                    }
                }
            }
        }
        if (pick) {
            addRet(info);
        }
    }

    private ExamRecordQuestionsEntity getStudentAnswer(Long recordId) {
        Query query = new Query();
        query.addCriteria(Criteria.where("examRecordDataId").is(recordId));
        List<ExamRecordQuestionsEntity> ret = oeTemplate.find(query, ExamRecordQuestionsEntity.class,
                "examRecordQuestions");
        if (CollectionUtils.isEmpty(ret)) {
            return null;
        }
        return ret.get(0);
    }

}
